#version 450
#extension GL_EXT_buffer_reference : require


layout(buffer_reference, buffer_reference_align = 16) buffer ObjectBuffer {
  mat4 model[];
};

layout( push_constant ) uniform constants {
  ObjectBuffer objects;
} scene_pc;

layout(set = 0, binding = 0) uniform SceneUniform {
  mat4 view;
  mat4 proj;
} scene;

layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec3 inColor;

layout(location = 0) out vec3 fragColor;

void main() {
  gl_Position = scene.proj * scene.view * scene_pc.objects.model[0] * vec4(inPosition, 1.0);
  fragColor = inColor;
}
